#!/usr/bin/automake
#! -*- coding:utf-8; mode:makefile-automake; -*-


## Copyright (c) 2014 Moritz Klammler
##
## Permission is  hereby granted, free  of charge,  to any person  obtaining a
## copy of this software and  associated documentation files (the "Software"),
## to deal in  the Software without restriction,  including without limitation
## the rights  to use, copy,  modify, merge, publish,  distribute, sublicense,
## and/or  sell copies  of the  Software, and  to permit  persons to  whom the
## Software is furnished to do so, subject to the following conditions:
##
## The above copyright notice and this  permission notice shall be included in
## all copies or substantial portions of the Software.
##
## THE SOFTWARE IS PROVIDED "AS IS",  WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
## IMPLIED, INCLUDING  BUT NOT LIMITED  TO THE WARRANTIES  OF MERCHANTABILITY,
## FITNESS FOR  A PARTICULAR PURPOSE  AND NONINFRINGEMENT.  IN NO  EVENT SHALL
## THE AUTHORS OR COPYRIGHT HOLDERS BE  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
## LIABILITY, WHETHER  IN AN  ACTION OF CONTRACT,  TORT OR  OTHERWISE, ARISING
## FROM,  OUT OF  OR IN  CONNECTION  WITH THE  SOFTWARE  OR THE  USE OR  OTHER
## DEALINGS IN THE SOFTWARE.


# This file does not contain valid syntax.  It uses indentation to make the
# Automake conditionals more readable and therefore must be "dedented" before
# it can be 'include'd into 'Makefile.am'.  This will be done automagically.


bin_PROGRAMS = benchmark_selfmade
benchmark_selfmade_SOURCES = benchmark_selfmade.cpp common.hpp

if HAVE_OPENMP
  bin_PROGRAMS += benchmark_selfmade_mp
  benchmark_selfmade_mp_SOURCES = benchmark_selfmade.cpp
  benchmark_selfmade_mp_CXXFLAGS = ${OPENMP_CXXFLAGS}
endif HAVE_OPENMP

if HAVE_CBLAS
  bin_PROGRAMS += benchmark_cblas benchmark_cblas_mp
  benchmark_cblas_SOURCES = benchmark_cblas.cpp
  benchmark_cblas_mp_SOURCES = benchmark_cblas.cpp
  benchmark_cblas_LDADD = ${CBLAS_LIBS} ${BLAS_LIBS} ${FLIBS}
  benchmark_cblas_mp_LDADD = ${CBLAS_LIBS} ${BLAS_MP_LIBS} ${FLIBS}
endif HAVE_CBLAS

if HAVE_EIGEN
  bin_PROGRAMS += benchmark_eigen
  benchmark_eigen_SOURCES = benchmark_eigen.cpp
  if HAVE_OPENMP
    bin_PROGRAMS += benchmark_eigen_mp
    benchmark_eigen_mp_SOURCES = benchmark_eigen.cpp
    benchmark_eigen_mp_CXXFLAGS = ${OPENMP_CXXFLAGS}
  endif HAVE_OPENMP
  if WITH_MKL
    bin_PROGRAMS += benchmark_eigen_mkl
    benchmark_eigen_mkl_SOURCES = benchmark_eigen.cpp
    benchmark_eigen_mkl_CPPFLAGS = -DWITH_MKL=1
    benchmark_eigen_mkl_LDADD = ${MKL_LIBS}
    if HAVE_OPENMP
      bin_PROGRAMS += benchmark_eigen_mkl_mp
      benchmark_eigen_mkl_mp_SOURCES = benchmark_eigen.cpp
      benchmark_eigen_mkl_mp_CPPFLAGS = -DWITH_MKL=1
      benchmark_eigen_mkl_mp_CXXFLAGS = ${OPENMP_CXXFLAGS}
      benchmark_eigen_mkl_mp_LDADD = ${MKL_MP_LIBS}
    endif HAVE_OPENMP
  endif WITH_MKL
endif HAVE_EIGEN

if HAVE_TNT
  bin_PROGRAMS += benchmark_tnt
  benchmark_tnt_SOURCES = benchmark_tnt.cpp
endif HAVE_TNT

if HAVE_UBLAS
  bin_PROGRAMS += benchmark_ublas
  benchmark_ublas_SOURCES = benchmark_ublas.cpp
  if WITH_MKL
    if HAVE_UBLAS_MKL
      bin_PROGRAMS += benchmark_ublas_mkl benchmark_ublas_mkl_mp
      benchmark_ublas_mkl_SOURCES = benchmark_ublas.cpp
      benchmark_ublas_mkl_mp_SOURCES = benchmark_ublas.cpp
      benchmark_ublas_mkl_CPPFLAGS = -DWITH_MKL=1
      benchmark_ublas_mkl_mp_CPPFLAGS = -DWITH_MKL=1
      benchmark_ublas_mkl_LDADD = ${MKL_LIBS}
      benchmark_ublas_mkl_mp_LDADD = ${MKL_MP_LIBS}
    endif HAVE_UBLAS_MKL
  endif WITH_MKL
endif HAVE_UBLAS
